@ECHO OFF
SETLOCAL enabledelayedexpansion

:: THIS SCRIPT FILE NEEDS TO BE IN ASCII FOR THE CHARACTER REPLACEMENTS TO WORK
:: If working with utf8 chars to be replaced, set this script file to be in utf-8 and change the codepage, see
:: https://stackoverflow.com/questions/5273937/how-to-replace-substrings-in-windows-batch-file
::chcp 65001

set origdir=%CD%

set odir=import
if not exist %odir% mkdir %odir%


:: Process each CSV file. Each CSV file is assumed by procCrate to be in ASCII not UTF-8!
call :procCrate "Crates A-1.csv" "A-1" "Crate A Science - Primary"
call :procCrate "Crates A-2.csv" "A-2" "Crate A Science - Primary"

call :procCrate "Crates B-1.csv" "B-1" "Crate B Science - Primary"
call :procCrate "Crates B-2.csv" "B-2" "Crate B Science - Primary"

call :procCrate "Crates C-1.csv" "C-1" "Crate C Biology - Secondary"
call :procCrate "Crates C-2.csv" "C-2" "Crate C Biology - Secondary"
call :procCrate "Crates C-3.csv" "C-3" "Crate C Biology - Secondary"

call :procCrate "Crates D-1.csv" "D-1" "Crate D Science - Secondary"
call :procCrate "Crates D-2.csv" "D-2" "Crate D Science - Secondary"

call :procCrate "Crates E-1.csv" "E-1" "Crate E - Generic"
call :procCrate "Crates E-2.csv" "E-2" "Crate E - Generic"
call :procCrate "Crates E-3.csv" "E-3" "Crate E - Generic"

call :procCrate "Crates F-1.csv" "F-1" "Crate F - Chemistry"
call :procCrate "Crates F-2.csv" "F-2" "Crate F - Chemistry"

:: UNUSED
rem call :procCrate "origcsv_Crates.csv" "A-1" "Crate A Science - Primary"


:end
ENDLOCAL
GOTO :EOF


:procCrate
rem IF [%1]==[] (
rem 	echo.
rem 	echo ************************************************************************
rem 	echo.
rem 	echo This script must reside directly inside your TT4.02_Science Resources_Crates folder which must furthermore contain your CSV files for each crate.
rem 	echo.
rem 	echo Usage: %0 "csv-file" "crate" "cratename"
rem 	echo		Example: %0 "C:\PATH\TO\Crates (TT4.02) A-1.csv" "A-1" "Crate A Science - Primary"
rem 	echo.
rem 	echo ************************************************************************
rem 	echo.
rem 	goto end
rem )


:: store params stripped of any double quotes
:: https://stackoverflow.com/questions/1964192/removing-double-quotes-from-variables-in-batch-file-creates-problems-with-cmd-en
set csvfile=%1
set csvfile=%csvfile:"=%

set crate=%2
set crate=%crate:"=%

set crateName=%3
set crateName=%crateName:"=%

echo.
echo PROCESSING:
echo 	CSVfile: %csvfile%
echo 	Crate: [%crate%] --- Crate Name: %crateName%
echo ***********
echo.

FOR /F "usebackq tokens=1,2 delims=," %%G in ("%csvfile%") do (

	rem echo %%G
	rem echo(%%H

	:: skip rows in the CSV file that aren't of the form: activity,activityName
	rem https://stackoverflow.com/questions/36355490/continue-equivalent-command-in-nested-loop-in-windows-batch
	:: only if we have an activityName column for this row, do we process this row
	if [%%H]==[] (
		echo ^(not an activity row^)
	) else (
		set activity=%%G
		
		rem set activity=%activity:"=%
		
		rem set activityName=%%H inside for loop will leave activityName empty without doing setlocal enabledelayedexpansion above
		rem https://stackoverflow.com/questions/23525681/how-to-print-variable-inside-loop-in-batch-script
		rem Didn't seem to make a difference for me: https://stackoverflow.com/questions/4333754/problem-with-search-and-replace-batch-file	
		
		
		set activityName=%%H
		
		rem echo Activity Name (before cleaning): !activityName!
		
		rem clean the activity name to deal with ampersands, and the stylised double quotes, hyphens and ellipses,
		rem single quotes, and any others (e.g. 3/4 fraction) that change in Notepad++'s Encoding > Encode in UTF-8 file-view
		set activityName=!activityName:=...!
		set activityName=!activityName:=-!
		set activityName=!activityName:^&=and!
		set activityName=!activityName:/=;!
		rem finally, remove the regular double quotes around parameter before converting stylised double quotes to ASCII double quotes
		REM set activityName=!activityName:"=!
		set activityName=!activityName:="!
		set activityName=!activityName:="!
		set activityName=!activityName:='!
		set activityName=!activityName:='!
		set activityName=!activityName:=3/4!
		
		echo Activity: [!activity!] --- ^(cleaned^) Activity Name: [!activityName!]
		
		if not exist %odir%\%crate% mkdir %odir%\%crate%
		pushd %odir%\%crate%
		
		rem NOTE: setdelayedexpansion to use exclamation marks requires double caret escaping to echo the exclamation mark
		echo ^<?xml version="1.0" encoding="UTF-8"?^> > metadata.xml
		echo ^<^^!DOCTYPE DirectoryMetadata SYSTEM "http://greenstone.org/dtd/DirectoryMetadata/1.0/DirectoryMetadata.dtd"^> >> metadata.xml
		echo ^<DirectoryMetadata^> >> metadata.xml
		echo 	^<FileSet^> >> metadata.xml
		echo 		^<FileName^>.*^</FileName^> >> metadata.xml
		echo 		^<Description^> >> metadata.xml
		echo				^<Metadata mode="accumulate" name="er.Crate"^>%crate%^</Metadata^> >> metadata.xml
		echo				^<Metadata mode="accumulate" name="er.CrateName"^>%crateName%^</Metadata^> >> metadata.xml
		echo 		^</Description^> >> metadata.xml
		echo 	^</FileSet^> >> metadata.xml
		echo ^</DirectoryMetadata^> >> metadata.xml
		
		popd
		
		if not exist %odir%\%crate%\!activity! mkdir %odir%\%crate%\!activity!
		pushd %odir%\%crate%\!activity!

		echo ^<?xml version="1.0" encoding="UTF-8"?^> > metadata.xml
		echo ^<^^!DOCTYPE DirectoryMetadata SYSTEM "http://greenstone.org/dtd/DirectoryMetadata/1.0/DirectoryMetadata.dtd"^> >> metadata.xml
		echo ^<DirectoryMetadata^> >> metadata.xml
		echo 	^<FileSet^> >> metadata.xml
		echo 		^<FileName^>.*^</FileName^> >> metadata.xml
		echo 		^<Description^> >> metadata.xml
	rem Crate|Activity
	rem	echo				^<Metadata mode="accumulate" name="er.CrateHierarchy"^>%crate%^|!activity!^</Metadata^> >> metadata.xml
	rem Crate: CrateName|Activity: ActivityName
		echo				^<Metadata mode="accumulate" name="er.CrateHierarchy"^>%crate%: %crateName%^|!activity!: !activityName!^</Metadata^> >> metadata.xml
		echo				^<Metadata mode="accumulate" name="er.Activity"^>!activity!^</Metadata^> >> metadata.xml
		echo				^<Metadata mode="accumulate" name="er.ActivityName"^>!activityName!^</Metadata^> >> metadata.xml
		echo 		^</Description^> >> metadata.xml
		echo 	^</FileSet^> >> metadata.xml
		echo ^</DirectoryMetadata^> >> metadata.xml
		
		if exist "%origdir%\Crate %crate%\!activity!*" copy "%origdir%\Crate %crate%\!activity!.*" .		
		if exist "%origdir%\Crate %crate%\!activity!_*" copy "%origdir%\Crate %crate%\!activity!_*" .
		if exist "%origdir%\Crate %crate%\!activity!-*" copy "%origdir%\Crate %crate%\!activity!-*" .
		if exist "%origdir%\Crate %crate%\!activity!^(*" copy "%origdir%\Crate %crate%\!activity!^(*" .
		
		if exist "%origdir%\Crate %crate%\Extra*" copy "%origdir%\Crate %crate%\Extra*" ..\.
		
		rem check for dir https://stackoverflow.com/questions/138981/how-to-test-if-a-file-is-a-directory-in-a-batch-script
		rem xcopy for recursively copying dirs: https://stackoverflow.com/questions/13314433/batch-file-to-copy-directories-recursively
		rem For loop to call xcopy on file glob *directory* name match https://ss64.com/nt/for.html
		rem For each source directory of files, copy it into the destination too		
		FOR /D %%G IN ("%origdir%\Crate %crate%\!activity!*") do (xcopy "%%G" . /s /e /i)		
		popd
	
	)
)
echo ********************************
goto :eof	

:: UNUSED
:skipLine
	echo ^(not a row^)
	goto :eof

:: UNUSED Call procLine with double-quoted %%G/activity and %%H/activityName (first 2 columns of csv files)
:procLine	
	set activity=%1
	set activity=%activity:"=%
	
	:: set activityName=%%H inside for loop will leave activityName empty without doing setlocal enabledelayedexpansion above
	:: https://stackoverflow.com/questions/23525681/how-to-print-variable-inside-loop-in-batch-script
	:: Didn't seem to make a difference for me: https://stackoverflow.com/questions/4333754/problem-with-search-and-replace-batch-file	
	
	
	set activityName=%2
	
	rem echo Activity Name (before cleaning): !activityName!
	
	:: clean the activity name to deal with ampersands, and the stylised double quotes, hyphens and ellipses, etc.	
	set activityName=!activityName:=...!
	set activityName=!activityName:=-!
	set activityName=!activityName:='!
	set activityName=!activityName:='!
	set activityName=!activityName:=3/4!
	set activityName=!activityName:^&=and!
	rem finally, remove the regular double quotes around parameter before converting stylised double quotes to ASCII double quotes	
	set activityName=!activityName:"=!
	set activityName=!activityName:="!
	set activityName=!activityName:="!	
		
	echo Activity: [!activity!] --- (cleaned) Activity Name: [!activityName!]
	
 
	if not exist %odir%\%crate% mkdir %odir%\%crate%
	pushd %odir%\%crate%
	
	echo ^<?xml version="1.0" encoding="UTF-8"?^> > metadata.xml
	echo ^<!DOCTYPE DirectoryMetadata SYSTEM "http://greenstone.org/dtd/DirectoryMetadata/1.0/DirectoryMetadata.dtd"^> >> metadata.xml
	echo ^<DirectoryMetadata^> >> metadata.xml
	echo 	^<FileSet^> >> metadata.xml
	echo 		^<FileName^>.*^</FileName^> >> metadata.xml
	echo 		^<Description^> >> metadata.xml
	echo				^<Metadata mode="accumulate" name="er.Crate"^>%crate%^</Metadata^> >> metadata.xml
	echo				^<Metadata mode="accumulate" name="er.CrateName"^>%crateName%^</Metadata^> >> metadata.xml
	echo 		^</Description^> >> metadata.xml
	echo 	^</FileSet^> >> metadata.xml
	echo ^</DirectoryMetadata^> >> metadata.xml
	
	popd
	
	if not exist %odir%\%crate%\!activity! mkdir %odir%\%crate%\!activity!
	pushd %odir%\%crate%\!activity!

	echo ^<?xml version="1.0" encoding="UTF-8"?^> > metadata.xml
	echo ^<!DOCTYPE DirectoryMetadata SYSTEM "http://greenstone.org/dtd/DirectoryMetadata/1.0/DirectoryMetadata.dtd"^> >> metadata.xml
	echo ^<DirectoryMetadata^> >> metadata.xml
	echo 	^<FileSet^> >> metadata.xml
	echo 		^<FileName^>.*^</FileName^> >> metadata.xml
	echo 		^<Description^> >> metadata.xml
:: Crate|Activity
rem	echo				^<Metadata mode="accumulate" name="er.CrateHierarchy"^>%crate%^|!activity!^</Metadata^> >> metadata.xml
:: Crate: CrateName|Activity: ActivityName
	echo				^<Metadata mode="accumulate" name="er.CrateHierarchy"^>%crate%: %crateName%^|!activity!: !activityName!^</Metadata^> >> metadata.xml
	echo				^<Metadata mode="accumulate" name="er.Activity"^>!activity!^</Metadata^> >> metadata.xml
	echo				^<Metadata mode="accumulate" name="er.ActivityName"^>!activityName!^</Metadata^> >> metadata.xml
	echo 		^</Description^> >> metadata.xml
	echo 	^</FileSet^> >> metadata.xml
	echo ^</DirectoryMetadata^> >> metadata.xml
	
	
	if exist "%origdir%\Crate %crate%\!activity!*" copy "%origdir%\Crate %crate%\!activity!.*" .
	if exist "%origdir%\Crate %crate%\!activity!_*" copy "%origdir%\Crate %crate%\!activity!_*" .
	if exist "%origdir%\Crate %crate%\!activity!-*" copy "%origdir%\Crate %crate%\!activity!-*" .
	if exist "%origdir%\Crate %crate%\!activity!^(*" copy "%origdir%\Crate %crate%\!activity!^(*" .
		
	if exist "%origdir%\Crate %crate%\Extra*" copy "%origdir%\Crate %crate%\Extra*" ..\.
	
	rem https://stackoverflow.com/questions/138981/how-to-test-if-a-file-is-a-directory-in-a-batch-script
	rem https://stackoverflow.com/questions/13314433/batch-file-to-copy-directories-recursively
	rem if exist "%origdir%\Crate %crate%\!activity!*\NUL" xcopy "%origdir%\Crate %crate%\!activity!*" . /s /e /i
	rem For folders of docs for an activity, the following XXcreates a target subfolder named activity and into it,XX copies the files from the source folder
	rem https://ss64.com/nt/for.html
	for /D %%G in ("%origdir%\Crate %crate%\!activity!*") do (xcopy "%%G" . /s /e /i)

 
	::if exist "%origdir%\Crate %crate%\Extra*" copy "%origdir%\Crate %crate%\Extra*" .\..
	popd
	endlocal
	
)
GOTO :EOF


